
code    segment
        assume  cs:code,ds:code
        org     100h

entry:  jmp     begin

; Wertetabelle fr Kamerafahrt

buf     db      38400 dup (0)           ; double-Buffering-Speicher

posCnt  db      0
posNum  db      1

pos1    dd      0
        dd      0

                ; add_cx,    add_dx,      sub_cx,      sub_dx,
pos2    dd      1638 * 256, 1228 * 256, 98304 * 256, 131072 * 256
                ; jmp_v,        leave_cx,       leave_dx
        dd      262144 * 256, 0ffffh*3 * 256,  97212 * 256

  begin:
        mov     ax,0013h
        int     10h

        cld

        mov     ax,0a000h
        mov     es,ax

        push    cs
        pop     ds

        ; Variablen/Code mit Startwerten besetzen

        mov     di,0
    .386
        xor     ecx,ecx         ; y - Zhler

    yloop:          ; Schritteweitekonstante an 14bit und Gre angepat
 @add_cx:
        add     ecx,1638 *256        ; y - Schrittweite -> Transformation
                    ; y-Schrittweite = 3*16b / 180 = 20b->3145728/180
        xor     edx,edx         ; x - Zhler
        mov     si,80
        add     di,320

    xloop:          ; siehe oben
 @add_dx:
        add     edx,1228 *256      ; x - Schrittweite -> Transformation
        inc     si

      ; rek-tiefe berechnen
        ; eax wird reell-Teil und ebx imag.-teil / esi ist Puffer
        ; x' = x2 - y2 + a    /    y' = 2xy + b

        push    si
        push    di
        push    ecx
        push    edx

 @sub_cx:
        sub     ecx,98304 *256      ; Parameterkorrektur
 @sub_dx:
        sub     edx,131072 *256

        xor     eax,eax         ; immer mit 0 anfangen
        xor     ebx,ebx
        xor     bp,bp

    iloop:
        inc     bp

        push    eax
        push    ebx

          push    edx

            mov     esi,eax
            imul    esi
            shrd    eax,edx,24

            xchg    eax,ebx

            mov     esi,eax
            imul    esi
            shrd    eax,edx,24

          pop     edx

        mov     edi,eax
        add     edi,ebx
 @jmp_v:
        cmp     edi,262144  *256  ; >4 dann weg
        ja      @fin

        sub     ebx,eax       ; x2-y2 (eax und ebx getauscht)
        add     ebx,edx       ; + a
        mov     edi,ebx       ; Puffer fr x'

        pop     ebx
        pop     eax

        push    edx

        imul    ebx
        shrd    eax,edx,24
        shl     eax,1         ; Ergebnis noch mal 2 nehmen! ( -> y'=x*y*2 )

        add     eax,ecx       ; y' fertig machen

        pop     edx

        mov     ebx,edi
        xchg    eax,ebx

        cmp     bp,16         ; hier Tsch (iteration)
        jb      iloop

        xor     bp,bp
        jmp     @fin3

       @fin:
        pop     ebx
        pop     eax

       @fin3:
        pop     edx
        pop     ecx
        pop     di
        pop     si

      ; Pixel setzen

        mov     ax,bp                   ; Farbe in ah speichern
        xchg    ah,al

        push    di                      ; di ist y-Zhler und si x-Zhler
        add     di,si
        mov     byte ptr ds:[di],ah     ; Farbe in ah
        pop     di

        push    di
        mov     bx,38400
        sub     bx,di
        xchg    di,bx
        add     di,si
        mov     byte ptr ds:[di],ah
        pop     di

      ; xloop-cmp
 @lea_dx:
        cmp     edx,0ffffh*3 *256
        jb      xloop

      ; yloop-cmp
 @lea_cx:
        cmp     ecx,97212 * 256   ;  0ffffh*3 *256
        jb      yloop

  copy:
        mov     cx,38240 / 4  ; soso!
        mov     di,12880
        mov     si,400
        rep     movsd

  done:
        mov     ax,0
        int     16h
        mov     ax,0003h
        int     10h
        mov     ah,4ch
        int     21h

code    ends
        end     entry

